Description

I just noticed "My page" personalization does not fully work:

You can add/remove blocks, but after reordering blocks the layout is not stored.

Tested with Safari 3.2.1 and FireFox 3.0.1, this can be reproduced on http://www.redmine.org.

One reason is MyController#order_blocks expects params[:group] to be an array, which simply is not the case, also

params["list-#{group}"] may actually be empty if the user just dragged the last item out of a group.

A patch for these issues is attached.

Note that there may still be a race condition because of concurrent AJAX calls when the session is stored within cookies.

(Basically the same session is received twice - once for the removal, once for adding - changed and sent back, one change

overwriting the other)

Redmine trunk (r2589)

Ruby 1.8.6

Rails 2.2.2

Postgres 8.3

Associated revisions

Revision 2634 - 2009-03-26 19:11 - Jean-Philippe Lang

Fixes that "My Page" personalization was not storing reordered blocks (#2971).

Revision 3194 - 2009-12-19 14:32 - Jean-Philippe Lang

Fixes block reordering on my page (#2971).

History

#1 - 2009-03-18 16:25 - Curtis Stewart

+1

I will be interested when this patch gets incorporated also. I have had a few people ask about it.

#2 - 2009-03-26 19:09 - Jean-Philippe Lang

- Status changed from New to Resolved

- Target version set to 0.8.3

Patch applied in r2634. Thanks.

Rather than storing the changes in session, we should write them directly in the database.

#3 - 2009-03-28 17:41 - Chaoqun Zou

There are still some problems in changing layout:

Add more than one components to both left-bottom and right-bottom areas, save layout.

Move components between two bottom areas, save layout.

If you do these several times, you will find that some component will be lost sometimes.

#4 - 2009-04-05 14:05 - Jean-Philippe Lang

- Status changed from Resolved to Reopened

- Target version changed from 0.8.3 to 0.9.0
I'll do some more testing.

#5 - 2009-04-20 14:40 - Anonymous

I'm having the same problem, even on redmine.org

It seems if it move something to the top block I'll never be able to move it to either of the bottom 2 blocks.

#6 - 2009-12-19 14:25 - Jean-Philippe Lang

- Status changed from Reopened to Closed

This should be fixed in r3194.

#7 - 2010-01-12 17:19 - Alex Revetchi

- Status changed from Closed to Reopened

- Assignee set to Jean-Philippe Lang

Jean-Philippe Lang wrote:

This should be fixed in r3194.

 Why def page_layout_save has been removed, in 0.9 there is no save link on My page in customization mode.

#8 - 2010-01-13 11:28 - Alex Revetchi

Alex Revetchi wrote:

Jean-Philippe Lang wrote:

This should be fixed in r3194.

 Why def page_layout_save has been removed, in 0.9 there is no save link on My page in customization mode.

 I have put back the code removed in a prevous commit and it works fine now:

app/views/my/page_layout.rhtml - after the line 48

+<%= link_to l(:button_save), {:action => 'page_layout_save'}, :class => 'icon icon-save' %>

app/controllers/my_controller.rb - restored page_layout_save routine at the end of the file

+  # Save user's page layout

+  def page_layout_save

+    user user = User.current

+    @user.pref[:my_page_layout] = session[:page_layout] if session[:page_layout]

+    @user.pref.save

+    session[:page_layout] = nil

+    redirect_to :action => 'page'

+  end

#9 - 2010-01-13 21:11 - Jean-Philippe Lang

- Status changed from Reopened to Closed

This code was removed because order is saved immediately after moving a block.

#10 - 2010-01-18 18:57 - Alex Revetchi

Jean-Philippe Lang wrote:

This code was removed because order is saved immediately after moving a block.

 There should be at least close button, what user should do in order to exit the customization mode? navigate away from that page?

#11 - 2010-01-18 19:56 - Jean-Philippe Lang

There is a 'Back' button for that.
#12 - 2010-01-19 00:52 - Alex Revetchi

Jean-Philippe Lang wrote:

There is a 'Back' button for that.

 Thanks, a lot, it was confusing as I was used to the previous interface, where back was canceling the changes i.e. not saving them.
